﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace TreeGridSample.Controllers
{
    public class TreeGridController : Controller
    {
        //
        // GET: /TreeGrid/

        public ActionResult Index()
        {
            var DataSource = TreeGridDefaultData.GetData();
            ViewBag.datasource = DataSource;
            ViewBag.resource = ResourceList.GetResources();
            return View();
        }

        public class Resource
        {
            public int ResourceId { get; set; }
            public string ResourceName { get; set; }

        }

        //...
        public class ResourceList
        {
            public static List<Resource> GetResources()
            {
                List<Resource> ResourceCollection = new List<Resource>();
                ResourceCollection.Add(new Resource() { ResourceId = 1, ResourceName = "Project Manager" });
                ResourceCollection.Add(new Resource() { ResourceId = 2, ResourceName = "Software Analyst" });
                ResourceCollection.Add(new Resource() { ResourceId = 3, ResourceName = "Developer" });
                ResourceCollection.Add(new Resource() { ResourceId = 4, ResourceName = "Testing Engineer" });
                return ResourceCollection;
            }

        }

        public class DefaultData
        {
            public string StartDate { get; set; }
            public int Id { get; set; }
            public string Name { get; set; }
            public string Duration { get; set; }
            public int PercentDone { get; set; }
            public List<object> ResourceId { get; set; }
            public List<DefaultData> Children { get; set; }
        }

        public class TreeGridDefaultData
        {
            public static List<DefaultData> GetData()
            {
                List<DefaultData> list = new List<DefaultData>();
                list.Add(new DefaultData()
                {
                    Id = 1,
                    Name = "Parent Task Level 1",
                    StartDate = "02/23/2014",
                    PercentDone = 40,
                    Duration="",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 2,
                            Name = "Parent Level 2 Task 1",
                            StartDate = "02/23/2014",
                            Duration = "33",
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                            Children = (new List<DefaultData>()
                            {
                                
                                        new DefaultData()
                                        {
                                            Id = 3,
                                            Name = "Child Task 1",
                                            StartDate = "02/23/2014",
                                            PercentDone = 50,     
                                            Duration="8",
                                            ResourceId=new List<object>(){1,2}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 4,
                                            Name = "Child Task 2",
                                            StartDate = "02/26/2014",
                                            PercentDone = 60,
                                            Duration="33",
                                            ResourceId=new List<object>(){4}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 5,
                                            Name = "Child Task 3",
                                            StartDate = "02/23/2014",
                                            PercentDone = 50,
                                            Duration="7",
                                            ResourceId=new List<object>(){2}                                
                                        }
                                                               
                            })
                        },                        
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 6,
                    Name = "Parent Task Level 2",
                    StartDate = "02/23/2014",
                    PercentDone = 40,
                    Duration = "",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 7,
                            Name = "Parent Level 2 Task 1",
                            StartDate = "02/23/2014",
                            Duration = "3",
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                            Children = (new List<DefaultData>()
                            {
                                
                                        new DefaultData()
                                        {
                                            Id = 8,
                                            Name = "Child Task 1",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,     
                                            Duration="8",
                                            ResourceId=new List<object>(){1,2}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 9,
                                            Name = "Child Task 2",
                                            StartDate = "02/26/2014",
                                            PercentDone = 40,
                                            Duration="4",
                                            ResourceId=new List<object>(){4}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 10,
                                            Name = "Child Task 3",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,
                                            Duration="7",
                                            ResourceId=new List<object>(){2}                                
                                        }
                                                               
                            })
                        },                        
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 11,
                    Name = "Parent Task Level 3",
                    StartDate = "02/23/2014",
                    PercentDone = 40,
                    Duration = "",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 12,
                            Name = "Parent Level 2 Task 1",
                            StartDate = "02/23/2014",
                            Duration = "3",
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                            Children = (new List<DefaultData>()
                            {
                                
                                        new DefaultData()
                                        {
                                            Id = 13,
                                            Name = "Child Task 1",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,     
                                            Duration="8",
                                            ResourceId=new List<object>(){1,2}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 14,
                                            Name = "Child Task 2",
                                            StartDate = "02/26/2014",
                                            PercentDone = 40,
                                            Duration="4",
                                            ResourceId=new List<object>(){4}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 15,
                                            Name = "Child Task 3",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,
                                            Duration="7",
                                            ResourceId=new List<object>(){2}                                
                                        }
                                                               
                            })
                        },                        
                    })
                });
                list.Add(new DefaultData()
                {
                    Id = 16,
                    Name = "Parent Task Level 4",
                    StartDate = "02/23/2014",
                    PercentDone = 40,
                    Duration = "",
                    Children = (new List<DefaultData>()
                    {
                        new DefaultData()
                        {
                            Id = 17,
                            Name = "Parent Level 2 Task 1",
                            StartDate = "02/23/2014",
                            Duration = "3",
                            PercentDone = 40,                                   
                            ResourceId=new List<object>(){1,2},
                            Children = (new List<DefaultData>()
                            {
                                
                                        new DefaultData()
                                        {
                                            Id = 18,
                                            Name = "Child Task 1",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,     
                                            Duration="8",
                                            ResourceId=new List<object>(){1,2}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 19,
                                            Name = "Child Task 2",
                                            StartDate = "02/26/2014",
                                            PercentDone = 40,
                                            Duration="4",
                                            ResourceId=new List<object>(){4}
                                        },
                                        new DefaultData()
                                        {
                                            Id = 20,
                                            Name = "Child Task 3",
                                            StartDate = "02/23/2014",
                                            PercentDone = 40,
                                            Duration="7",
                                            ResourceId=new List<object>(){2}                                
                                        }
                                                               
                            })
                        },                        
                    })
                });
                return list;
            }
        }
    }
}
